﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace setka
{
    class Program
    {
        static void Main(string[] args)
        {


            int a = 5; 
            int b = 5; 
            int n = 6;
            double h = 0.2; 
            double e = 0.0001; 

            int i, j, k;
            double[,] u = new double[n, n];
            double x, t, s, f, f1, f2, f3, f4;

            s = 1;


            
            for (i = 0; i <= a; i++)
            {
                x = i * h;
                f3 = x;
                f4 =  x + 1;
                u[i, 0] = f3;
                u[i, b] = f4;
            }

            
            for (j = 0; j <= b; j++)
            {
                t = j * h;
                f1 = t;
                f2 = 1 + t;
                u[0, j] = f1;
                u[a, j] = f2;
            }
            Console.WriteLine();
            Console.WriteLine("Setka s grani4nimi yslovi9mi:");
            Console.WriteLine();
            for (i = a; i >= 0; i--)
            {
                Console.Write("{0,2:f2} ", 1 - i * h);
                for (j = 0; j <= b; j++)
                {
                    Console.Write("{0,3:f4} ", u[j, i]);
                }
                Console.WriteLine();
            }
            Console.WriteLine("y/x  ");
            for (i = 0; i <= a; i++)
            {
                Console.Write("{0,3:f4} ", i * h);
            }
            //рш см мет Зайделя

            k = 0;
            do
            {
                k = k + 1; //підрах ітерацій
                for (i = 1; i < a; i++)
                {
                    for (j = 1; j < b; j++)
                    {
                        f = u[i, j];   
                        u[i, j] = (u[i + 1, j] + u[i - 1, j] + u[i, j + 1] + u[i, j - 1]) / 4; //решение системы методом Зайделя
                        s = Math.Abs(f - u[i, j]); 
                    }
                }

                Console.WriteLine();
                Console.WriteLine("iterazi9 nomer " + k);
                Console.WriteLine();
                for (i = a; i >= 0; i--)
                {
                    Console.Write("{0,2:f2} ", 1 - i * h);
                    for (j = 0; j <= b; j++)
                    {
                        Console.Write("{0,3:f4} ", u[j, i]);
                    }
                    Console.WriteLine();
                }
                Console.WriteLine("y/x  ");
                for (i = 0; i <= a; i++)
                {
                    Console.Write("{0,3:f4} ", i * h);
                }
            } while (s > e);
            
            double tmp = 0;
            
            Console.WriteLine();
            Console.WriteLine("Rezultati vipolneni9 programmi:");
            Console.WriteLine("koli4estvo iterazii i=" + k);
            Console.WriteLine();
            for (i = a; i >= 0; i--)
            {
                Console.Write("{0,2:f2} ", 1 - i * h);
                for (j = 0; j <= b; j++)
                {
                    tmp += (u[a - i, j] - (a - i) * h  - j * h) * (u[a - i, j] - (a - i) * h - j * h);
                    Console.Write("{0,3:f4} ", u[j, i]);
                }
                Console.WriteLine();
            }
            Console.Write("y/x ");
            for (i = 0; i <= a; i++)
            {
                Console.Write("{0,3:f4} ", i * h);
            }
            Console.WriteLine("pochybka: " + Math.Sqrt(tmp));
        }
    }
}